inlets = 1;
outlets = 1;

autowatch = 1;


dimX = jsarguments[1];
dimY = jsarguments[2];

// Jitter objects to use (also declared globally)
var myqtmovie = new JitterObject("jit.qt.movie", dimX, dimY);
var mymatrix = new JitterMatrix(4, "char", dimX, dimY); 
var outmatrix = new JitterMatrix(1, "char", dimX, dimY);
var myluma = new JitterObject("jit.rgb2luma");


var value = 30;
var offsetX = 0;
var offsetY = 0;


myqtmovie.unique = 1;


function loadbang() {
    
   //init some stuff
   init();
}


function reset()    {
    
    deleteBang();
    
    offsetX = 0;
    offsetY = 0;
}

function init() {

    var name;
    
    deleteBang();
    
    for (var x = 0; x < dimX; x++)  {
         for (var y = 0; y < dimY; y++)  {

        name = "bang_"+x+"_"+y;
        
        var obj = this.patcher.newdefault((x*20) + offsetX, (y*20) + offsetY, "button");
        obj.varname = name;
    
    
    
        }
    }

}

function deleteBang()   {

   for (var x = 0; x < dimX; x++)  {
         for (var y = 0; y < dimY; y++)  {

        var name = "bang_"+x+"_"+y;
            
        var a = this.patcher.getnamed(name);
        this.patcher.remove(a);
       
        }
    }
}

function read(filename) // read a movie
{
    if(arguments.length==0) { 
    // no movie specified, so open a dialog
        myqtmovie.read();
        init();
    }
    
    else { // read the movie specified
        myqtmovie.read(filename);
        init();
    }
}

function offset(x, y)   {

    offsetX = x;
    offsetY = y;

    init()
    
}

function bang() 
// perform one iteration of the playback / processing loop
{

    // process

    // get new matrix from movie ([jit.qt.movie]):
    myqtmovie.matrixcalc(mymatrix, mymatrix);
    
    myluma.matrixcalc(mymatrix, outmatrix);
    
    outmatrix.op(">", value);
    
    // output processed matrix into Max
    outlet(0, "jit_matrix", outmatrix.name); 
    

    for (var x = 0; x < dimX; x++)  {
         for (var y = 0; y < dimY; y++)  {
        
            if (outmatrix.getcell(x,y) <= 0)  {
        
                var name = "bang_"+x+"_"+y;
                var obj = this.patcher.getnamed(name);
                obj.message("bang");
            }
        }
    }
}